import scrapy
import random

class WikiSpider(scrapy.Spider):
    name = 'wikispider'

    def __init__(self, *args, **kwargs):
        super(WikiSpider, self).__init__(*args, **kwargs)

        self.start_urls = [kwargs.get('start_url')]

    def parse(self, response):
        current_page = response.xpath('//title/text()').re(r'([^-]+) -')

        hiperlinks = response.xpath('//div[@id="mw-content-text"]/p/a')
        if len(hiperlinks) > 50:
            hiperlinks = random.sample(hiperlinks, 50)
        for hiperlink in hiperlinks:
            destination_page = hiperlink.re(r'title="([^"]+)"')[0]
            yield {
                    'start_page': current_page,
                    'end_page': destination_page
            }
            yield scrapy.Request(
                    response.urljoin(hiperlink.re(r'href="([^"]+)"')[0]),
                    callback=self.parse
            )
